<?php
/**
 * @param $str
 * @return void
 * 格式化打印
 */
function kouming_p($str)
{
    echo "<pre>";
    print_r($str);
    echo "</pre>";
}

/**
 * @param $string
 * @return array|string|string[]|null
 * 去除标点符号
 */
function kouming_removePunctuation($string)
{
    $string = kouming_toSemiangle($string);
    $preg = "/[,.!;:<>\?'\"@#$%^&*\(\)\-_\+=\|\\\{\}\[\]\/`]/i";
    return preg_replace($preg, "", $string);
}

/**
 * @param $str
 * @return string
 * 全角转为半角
 */
function kouming_toSemiangle($str)
{
    $arr = [
        '０' => '0',
        '１' => '1',
        '２' => '2',
        '３' => '3',
        '４' => '4',
        '５' => '5',
        '６' => '6',
        '７' => '7',
        '８' => '8',
        '９' => '9',
        'Ａ' => 'A',
        'Ｂ' => 'B',
        'Ｃ' => 'C',
        'Ｄ' => 'D',
        'Ｅ' => 'E',
        'Ｆ' => 'F',
        'Ｇ' => 'G',
        'Ｈ' => 'H',
        'Ｉ' => 'I',
        'Ｊ' => 'J',
        'Ｋ' => 'K',
        'Ｌ' => 'L',
        'Ｍ' => 'M',
        'Ｎ' => 'N',
        'Ｏ' => 'O',
        'Ｐ' => 'P',
        'Ｑ' => 'Q',
        'Ｒ' => 'R',
        'Ｓ' => 'S',
        'Ｔ' => 'T',
        'Ｕ' => 'U',
        'Ｖ' => 'V',
        'Ｗ' => 'W',
        'Ｘ' => 'X',
        'Ｙ' => 'Y',
        'Ｚ' => 'Z',
        'ａ' => 'a',
        'ｂ' => 'b',
        'ｃ' => 'c',
        'ｄ' => 'd',
        'ｅ' => 'e',
        'ｆ' => 'f',
        'ｇ' => 'g',
        'ｈ' => 'h',
        'ｉ' => 'i',
        'ｊ' => 'j',
        'ｋ' => 'k',
        'ｌ' => 'l',
        'ｍ' => 'm',
        'ｎ' => 'n',
        'ｏ' => 'o',
        'ｐ' => 'p',
        'ｑ' => 'q',
        'ｒ' => 'r',
        'ｓ' => 's',
        'ｔ' => 't',
        'ｕ' => 'u',
        'ｖ' => 'v',
        'ｗ' => 'w',
        'ｘ' => 'x',
        'ｙ' => 'y',
        'ｚ' => 'z',
        '（' => '(',
        '）' => ')',
        '〔' => '[',
        '〕' => ']',
        '【' => '[',
        '】' => ']',
        '〖' => '[',
        '〗' => ']',
        '“' => '"',
        '”' => '"',
        '‘' => '[',
        '’' => ']',
        '｛' => '{',
        '｝' => '}',
        '《' => '<',
        '》' => '>',
        '％' => '%',
        '＋' => '+',
        '—' => '-',
        '－' => '-',
        '～' => '-',
        '：' => ':',
        '。' => '.',
        '、' => ',',
        '，' => ',',
        '、' => '.',
        '；' => ';',
        '？' => '?',
        '！' => '!',
        '…' => '-',
        '‖' => '|',
        '”' => '"',
        '’' => '`',
        '‘' => '`',
        '｜' => '|',
        '〃' => '"',
        '　' => ' ',
    ];

    return strtr($str, $arr);
}

/**
 * @param $obj
 * @return array|mixed
 * 对象转数组
 */
function kouming_objectArray($obj)
{
    if (!$obj) {
        return $obj;
    }
    if (!is_object($obj) and !is_array($obj)) {
        return $obj;
    }
    $_arr = is_object($obj) ? get_object_vars($obj) : $obj;
    foreach ($_arr as $key => $val) {
        $val = (is_array($val) || is_object($val)) ? kouming_objectArray($val) : $val;
        $arr[$key] = $val;
    }
    return $arr;
}

/**
 * @param $length
 * @return string
 * 随机生成字符串32位
 */
function kouming_createNonceStr($length = 8)
{
    $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
    $str = "";
    for ($i = 0; $i < $length; $i++) {
        $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
    }
    return $str;
}

/**
 * @param $timeStamp
 * @param $randomStr
 * @param $token
 * @return string
 * 签名
 */
function kouming_arithmetic($timeStamp, $randomStr, $token)
{
    $arr['timeStamp'] = $timeStamp;
    $arr['randomStr'] = $randomStr;
    $arr['apiKey'] = $token;
    //按照首字母大小写顺序排序
    sort($arr, SORT_STRING);
    //拼接成字符串
    $str = implode($arr);
    //进行加密
    $signature = md5($str);
    //转换成大写
    $signature = strtoupper($signature);
    return $signature;
}

/**
 * @param $url
 * @param $postData
 * @param $header
 * @return bool|string
 * curl请求
 */
function kouming_post($url, $postData = [], $header = [])
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $output = curl_exec($ch);
    curl_close($ch);
    return $output;
}

/**
 * @param $params
 * @return array
 * 公共参数
 */
function kouming_public_parameter($params)
{
    $time = time();
    $random = kouming_createNonceStr();
    $signature = kouming_arithmetic($time, $random, $params["api_key"]);
    return [
        "user" => $params["user_id"],
        "time" => $time,
        "random" => $random,
        "signature" => $signature,
    ];
}
